import MultipleChoiceEdit from "@/components/Generation/multiple.choice.edit";
import Input from "@/components/Low/Input";
import Select from "@/components/Low/Select";
import {Difficulty, Exercise, ListeningExam} from "@/interfaces/exam";
import useExamStore from "@/stores/examStore";
import {getExamById} from "@/utils/exams";
import {playSound} from "@/utils/sound";
import {convertCamelCaseToReadable} from "@/utils/string";
import {Tab} from "@headlessui/react";
import axios from "axios";
import clsx from "clsx";
import {capitalize, sample} from "lodash";
import {useRouter} from "next/router";
import {useEffect, useState, Dispatch, SetStateAction} from "react";
import {BsArrowRepeat, BsCheck} from "react-icons/bs";
import {toast} from "react-toastify";
import WriteBlanksEdit from "@/components/Generation/write.blanks.edit";
import {generate} from "random-words";
import Checkbox from "@/components/Low/Checkbox";

const DIFFICULTIES: Difficulty[] = ["easy", "medium", "hard"];

const MULTIPLE_CHOICE = {type: "multipleChoice", label: "Multiple Choice"};
const WRITE_BLANKS_QUESTIONS = {
	type: "writeBlanksQuestions",
	label: "Write the Blanks: Questions",
};
const WRITE_BLANKS_FILL = {
	type: "writeBlanksFill",
	label: "Write the Blanks: Fill",
};
const WRITE_BLANKS_FORM = {
	type: "writeBlanksForm",
	label: "Write the Blanks: Form",
};
const MULTIPLE_CHOICE_3 = {
	type: "multipleChoice3Options",
	label: "Multiple Choice",
};

const PartTab = ({
	part,
	difficulty,
	availableTypes,
	index,
	setPart,
	updatePart,
}: {
	part?: ListeningPart;
	difficulty: Difficulty;
	availableTypes: {type: string; label: string}[];
	index: number;
	setPart: (part?: ListeningPart) => void;
	updatePart: Dispatch<SetStateAction<ListeningPart | undefined>>;
}) => {
	const [topic, setTopic] = useState("");
	const [isLoading, setIsLoading] = useState(false);
	const [types, setTypes] = useState<string[]>([]);

	const generate = () => {
		const url = new URLSearchParams();
		url.append("difficulty", difficulty);

		if (topic) url.append("topic", topic);
		if (types) types.forEach((t) => url.append("exercises", t));

		setPart(undefined);
		setIsLoading(true);
		axios
			.get(`/api/exam/listening/generate/listening_section_${index}${topic || types ? `?${url.toString()}` : ""}`)
			.then((result) => {
				playSound(typeof result.data === "string" ? "error" : "check");
				if (typeof result.data === "string") return toast.error("Something went wrong, please try to generate again.");
				setPart(result.data);
			})
			.catch((error) => {
				console.log(error);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const renderExercises = () => {
		return part?.exercises.map((exercise) => {
			switch (exercise.type) {
				case "multipleChoice":
					return (
						<>
							<h1>Exercise: Multiple Choice</h1>
							<MultipleChoiceEdit
								exercise={exercise}
								key={exercise.id}
								updateExercise={(data: any) =>
									updatePart((part?: ListeningPart) => {
										if (part) {
											const exercises = part.exercises.map((x) => (x.id === exercise.id ? {...x, ...data} : x)) as Exercise[];
											const updatedPart = {
												...part,
												exercises,
											} as ListeningPart;
											return updatedPart;
										}

										return part;
									})
								}
							/>
						</>
					);
				// TODO: This might be broken as they all returns the same
				case "writeBlanks":
					return (
						<>
							<h1>Exercise: Write Blanks</h1>
							<WriteBlanksEdit
								exercise={exercise}
								key={exercise.id}
								updateExercise={(data: any) => {
									updatePart((part?: ListeningPart) => {
										if (part) {
											return {
												...part,
												exercises: part.exercises.map((x) => (x.id === exercise.id ? {...x, ...data} : x)),
											} as ListeningPart;
										}

										return part;
									});
								}}
							/>
						</>
					);
				default:
					return null;
			}
		});
	};

	const toggleType = (type: string) => setTypes((prev) => (prev.includes(type) ? [...prev.filter((x) => x !== type)] : [...prev, type]));

	return (
		<Tab.Panel className="w-full bg-ielts-listening/20 min-h-[600px] h-full rounded-xl p-6 flex flex-col gap-4">
			<div className="flex flex-col gap-3">
				<label className="font-normal text-base text-mti-gray-dim">Exercises</label>
				<div className="flex flex-row -2xl:flex-wrap w-full gap-4 -md:justify-center justify-between">
					{availableTypes.map((x) => (
						<span
							onClick={() => toggleType(x.type)}
							key={x.type}
							className={clsx(
								"px-6 py-4 w-64 flex justify-center text-sm font-normal rounded-full border focus:outline-none cursor-pointer",
								"transition duration-300 ease-in-out",
								!types.includes(x.type)
									? "bg-white border-mti-gray-platinum"
									: "bg-ielts-listening/70 border-ielts-listening text-white",
							)}>
							{x.label}
						</span>
					))}
				</div>
			</div>
			<div className="flex gap-4 items-end">
				<Input type="text" placeholder="Grand Canyon..." name="topic" label="Topic" onChange={setTopic} roundness="xl" defaultValue={topic} />
				<button
					onClick={generate}
					disabled={isLoading || types.length === 0}
					data-tip="The passage is currently being generated"
					className={clsx(
						"bg-ielts-listening/70 border border-ielts-listening text-white w-full max-w-[200px] rounded-xl h-[70px]",
						"hover:bg-ielts-listening disabled:bg-ielts-listening/40 disabled:cursor-not-allowed",
						"transition ease-in-out duration-300",
						isLoading && "tooltip",
					)}>
					{isLoading ? (
						<div className="flex items-center justify-center">
							<BsArrowRepeat className="text-white animate-spin" size={25} />
						</div>
					) : (
						"Generate"
					)}
				</button>
			</div>
			{isLoading && (
				<div className="w-fit h-fit mt-12 self-center animate-pulse flex flex-col gap-8 items-center">
					<span className={clsx("loading loading-infinity w-32 text-ielts-listening")} />
					<span className={clsx("font-bold text-2xl text-ielts-listening")}>Generating...</span>
				</div>
			)}
			{part && (
				<>
					<div className="flex flex-col gap-2 w-full overflow-y-scroll scrollbar-hide">
						<div className="flex gap-4">
							{part.exercises.map((x) => (
								<span className="rounded-xl bg-white border border-ielts-listening p-1 px-4" key={x.id}>
									{x.type && convertCamelCaseToReadable(x.type)}
								</span>
							))}
						</div>
						{typeof part.text === "string" && <span className="w-full h-96">{part.text.replaceAll("\n\n", " ")}</span>}
						{typeof part.text !== "string" && (
							<div className="w-full h-96 flex flex-col gap-2">
								{part.text.conversation.map((x, index) => (
									<span key={index} className="flex gap-1">
										<span className="font-semibold">{x.name}:</span>
										{x.text.replaceAll("\n\n", " ")}
									</span>
								))}
							</div>
						)}
					</div>
					{renderExercises()}
				</>
			)}
		</Tab.Panel>
	);
};

interface ListeningPart {
	exercises: Exercise[];
	text:
		| {
				conversation: {
					gender: string;
					name: string;
					text: string;
					voice: string;
				}[];
		  }
		| string;
}

interface Props {
	id: string;
}

const ListeningGeneration = ({id}: Props) => {
	const [part1, setPart1] = useState<ListeningPart>();
	const [part2, setPart2] = useState<ListeningPart>();
	const [part3, setPart3] = useState<ListeningPart>();
	const [part4, setPart4] = useState<ListeningPart>();
	const [minTimer, setMinTimer] = useState(30);
	const [isLoading, setIsLoading] = useState(false);
	const [resultingExam, setResultingExam] = useState<ListeningExam>();
	const [difficulty, setDifficulty] = useState<Difficulty>(sample(DIFFICULTIES)!);
	const [isPrivate, setPrivate] = useState<boolean>(false);

	useEffect(() => {
		const part1Timer = part1 ? 5 : 0;
		const part2Timer = part2 ? 8 : 0;
		const part3Timer = part3 ? 8 : 0;
		const part4Timer = part4 ? 9 : 0;

		const sum = part1Timer + part2Timer + part3Timer + part4Timer;
		setMinTimer(sum > 0 ? sum : 5);
	}, [part1, part2, part3, part4]);

	const router = useRouter();

	const setExams = useExamStore((state) => state.setExams);
	const setSelectedModules = useExamStore((state) => state.setSelectedModules);

	const submitExam = () => {
		const parts = [part1, part2, part3, part4].filter((x) => !!x);
		console.log({parts});
		if (parts.length === 0) return toast.error("Please generate at least one section!");

		if (!id) {
			toast.error("Please insert a title before submitting");
			return;
		}

		setIsLoading(true);

		axios
			.post(`/api/exam/listening/generate/listening`, {
				id,
				parts,
				minTimer,
				difficulty,
				private: isPrivate,
			})
			.then((result) => {
				playSound("sent");
				console.log(`Generated Exam ID: ${result.data.id}`);
				toast.success(`Generated Exam ID: ${result.data.id}`);
				setResultingExam(result.data);

				setPart1(undefined);
				setPart2(undefined);
				setPart3(undefined);
				setPart4(undefined);
				setDifficulty(sample(DIFFICULTIES)!);
			})
			.catch((error) => {
				console.log(error);
				toast.error("Something went wrong!");
			})
			.finally(() => setIsLoading(false));
	};

	const loadExam = async (examId: string) => {
		const exam = await getExamById("listening", examId.trim());
		if (!exam) {
			toast.error("Unknown Exam ID! Please make sure you selected the right module and entered the right exam ID", {
				toastId: "invalid-exam-id",
			});

			return;
		}

		setExams([exam]);
		setSelectedModules(["listening"]);

		router.push("/exercises");
	};

	return (
		<>
			<div className="flex gap-4 w-full items-center">
				<div className="flex flex-col gap-3">
					<label className="font-normal text-base text-mti-gray-dim">Timer</label>
					<Input
						type="number"
						name="minTimer"
						onChange={(e) => setMinTimer(parseInt(e) < 15 ? 15 : parseInt(e))}
						value={minTimer}
						className="max-w-[300px]"
					/>
				</div>
				<div className="flex flex-col gap-3 w-1/2">
					<label className="font-normal text-base text-mti-gray-dim">Difficulty</label>
					<Select
						options={DIFFICULTIES.map((x) => ({
							value: x,
							label: capitalize(x),
						}))}
						onChange={(value) => (value ? setDifficulty(value.value as Difficulty) : null)}
						value={{value: difficulty, label: capitalize(difficulty)}}
						disabled={!!part1 || !!part2 || !!part3 || !!part4}
					/>
				</div>
				<div className="flex flex-col gap-3 w-fit h-fit">
					<div className="h-6" />
					<Checkbox isChecked={isPrivate} onChange={setPrivate}>
						Privacy (Only available for Assignments)
					</Checkbox>
				</div>
			</div>
			<Tab.Group>
				<Tab.List className="flex space-x-1 rounded-xl bg-ielts-listening/20 p-1">
					<Tab
						className={({selected}) =>
							clsx(
								"w-full rounded-lg py-2.5 text-sm font-medium leading-5 text-ielts-listening/70 flex gap-2 items-center justify-center",
								"ring-white ring-opacity-60 ring-offset-2 ring-offset-ielts-listening focus:outline-none focus:ring-2",
								"transition duration-300 ease-in-out",
								selected ? "bg-white shadow" : "text-blue-100 hover:bg-white/[0.12] hover:text-ielts-listening",
							)
						}>
						Section 1 {part1 && <BsCheck />}
					</Tab>
					<Tab
						className={({selected}) =>
							clsx(
								"w-full rounded-lg py-2.5 text-sm font-medium leading-5 text-ielts-listening/70 flex gap-2 items-center justify-center",
								"ring-white ring-opacity-60 ring-offset-2 ring-offset-ielts-listening focus:outline-none focus:ring-2",
								"transition duration-300 ease-in-out",
								selected ? "bg-white shadow" : "text-blue-100 hover:bg-white/[0.12] hover:text-ielts-listening",
							)
						}>
						Section 2 {part2 && <BsCheck />}
					</Tab>
					<Tab
						className={({selected}) =>
							clsx(
								"w-full rounded-lg py-2.5 text-sm font-medium leading-5 text-ielts-listening/70 flex gap-2 items-center justify-center",
								"ring-white ring-opacity-60 ring-offset-2 ring-offset-ielts-listening focus:outline-none focus:ring-2",
								"transition duration-300 ease-in-out",
								selected ? "bg-white shadow" : "text-blue-100 hover:bg-white/[0.12] hover:text-ielts-listening",
							)
						}>
						Section 3 {part3 && <BsCheck />}
					</Tab>
					<Tab
						className={({selected}) =>
							clsx(
								"w-full rounded-lg py-2.5 text-sm font-medium leading-5 text-ielts-listening/70 flex gap-2 items-center justify-center",
								"ring-white ring-opacity-60 ring-offset-2 ring-offset-ielts-listening focus:outline-none focus:ring-2",
								"transition duration-300 ease-in-out",
								selected ? "bg-white shadow" : "text-blue-100 hover:bg-white/[0.12] hover:text-ielts-listening",
							)
						}>
						Section 4 {part4 && <BsCheck />}
					</Tab>
				</Tab.List>
				<Tab.Panels>
					{[
						{
							part: part1,
							setPart: setPart1,
							types: [MULTIPLE_CHOICE, WRITE_BLANKS_QUESTIONS, WRITE_BLANKS_FILL, WRITE_BLANKS_FORM],
						},
						{
							part: part2,
							setPart: setPart2,
							types: [MULTIPLE_CHOICE, WRITE_BLANKS_QUESTIONS],
						},
						{
							part: part3,
							setPart: setPart3,
							types: [MULTIPLE_CHOICE_3, WRITE_BLANKS_QUESTIONS],
						},
						{
							part: part4,
							setPart: setPart4,
							types: [MULTIPLE_CHOICE, WRITE_BLANKS_QUESTIONS, WRITE_BLANKS_FILL, WRITE_BLANKS_FORM],
						},
					].map(({part, setPart, types}, index) => (
						<PartTab
							part={part}
							difficulty={difficulty}
							availableTypes={types}
							index={index + 1}
							key={index}
							setPart={setPart}
							updatePart={setPart}
						/>
					))}
				</Tab.Panels>
			</Tab.Group>
			<div className="w-full flex justify-end gap-4">
				{resultingExam && (
					<button
						disabled={isLoading}
						onClick={() => loadExam(resultingExam.id)}
						className={clsx(
							"bg-white border border-ielts-listening text-ielts-listening w-full max-w-[200px] rounded-xl h-[70px] self-end",
							"hover:bg-ielts-listening hover:text-white disabled:bg-ielts-listening/40 disabled:cursor-not-allowed",
							"transition ease-in-out duration-300",
						)}>
						Perform Exam
					</button>
				)}
				<button
					disabled={(!part1 && !part2 && !part3 && !part4) || isLoading}
					data-tip="Please generate all three passages"
					onClick={submitExam}
					className={clsx(
						"bg-ielts-listening/70 border border-ielts-listening text-white w-full max-w-[200px] rounded-xl h-[70px] self-end",
						"hover:bg-ielts-listening disabled:bg-ielts-listening/40 disabled:cursor-not-allowed",
						"transition ease-in-out duration-300",
						!part1 && !part2 && !part3 && !part4 && "tooltip",
					)}>
					{isLoading ? (
						<div className="flex items-center justify-center">
							<BsArrowRepeat className="text-white animate-spin" size={25} />
						</div>
					) : (
						"Submit"
					)}
				</button>
			</div>
		</>
	);
};

export default ListeningGeneration;
